> ## Documentation Index
> Fetch the complete documentation index at: https://developers.notion.com/llms.txt
> Use this file to discover all available pages before exploring further.

> Creates and appends new children blocks to the parent `block_id` specified. Blocks can be parented by other blocks, pages, or databases.

# Append block children

Returns a paginated list of newly created first level children [block objects](/reference/block).

Existing blocks cannot be moved using this endpoint. Once a block is appended as a child, it can't be moved elsewhere via the API.

For blocks that allow children, we allow up to **two** levels of nesting in a single request.

There is a limit of **100 block children** that can be appended by a single API request. Arrays of block children longer than 100 will result in an error.

### Controlling insert position

By default, blocks are appended to the end of the parent block's children. Use the `position` parameter to insert blocks at a specific location:

| Position type | Description |
| - | - |
| `{ "type": "end" }` | Insert at the end of the parent's children (default behavior) |
| `{ "type": "start" }` | Insert at the beginning of the parent's children |
| `{ "type": "after_block", "after_block": { "id": "<block_id>" } }` | Insert after the specified block |

<CodeGroup>
  ```json Insert at start theme={null}
  {
    "children": [/* blocks */],
    "position": { "type": "start" }
  }
  ```

  ```json Insert after specific block theme={null}
  {
    "children": [/* blocks */],
    "position": {
      "type": "after_block",
      "after_block": { "id": "12345678-1234-1234-1234-123456789abc" }
    }
  }
  ```
</CodeGroup>

<Warning>
  **Deprecated parameter**

  The `after` parameter is deprecated. Use the `position` parameter instead, which provides more flexibility including inserting at the start of the children list.

  If you're currently using `after`, migrate to `position` with type `after_block`:

  * **Before:** `{ "children": [...], "after": "<block_id>" }`
  * **After:** `{ "children": [...], "position": { "type": "after_block", "after_block": { "id": "<block_id>" } } }`

  You cannot specify both `after` and `position` in the same request.
</Warning>

### Control notifications from page writes

Set `notifications.mode` to `silent` to skip the notifications Notion sends people about the change:

* Page update notifications to people who get updates for the page through **Notify me**.
* Notifications to people the content @mentions.
* Notifications to people the change adds to a Person property.

Set it to `default`, or omit `notifications`, to use the standard behavior.

Some effects of the change happen in either mode:

* [Database automations](https://www.notion.com/help/database-automations) that the change triggers still run, including **Send notification to** actions.
* Reminders set by the change still go off at their scheduled time.
* [Connection webhooks](/reference/webhooks) still receive events for the change.
* Page history, page activity, and workspace audit logs still record the change.

<Info>
  **Connection capabilities**

  This endpoint requires a connection to have insert content capabilities. Attempting to call this API without insert content capabilities will return an HTTP response with a 403 status code. For more information on connection capabilities, see the [capabilities guide](/reference/capabilities).
</Info>

### Errors

Returns a 404 HTTP response if the block specified by `id` doesn't exist, or if the connection doesn't have access to the block.

Returns a 400 or 429 HTTP response if the request exceeds the [request limits](/reference/request-limits).

*Note: Each Public API endpoint can return several possible error codes. To see a full description of each type of error code, see the [Error codes section](/reference/status-codes#error-codes) of the Status codes documentation.*


## OpenAPI

````yaml patch /v1/blocks/{block_id}/children
openapi: 3.1.0
info:
  title: Notion API
  version: 1.0.0
  termsOfService: >-
    https://notion.notion.site/Terms-and-Privacy-28ffdd083dc3473e9c2da6ec011b58ac
servers:
  - url: https://api.notion.com
security:
  - bearerAuth: []
tags:
  - name: Agent Skills
    description: Skill and plugin directory endpoints
  - name: Databases
    description: Database endpoints
  - name: Data sources
    description: Data source endpoints
  - name: Pages
    description: Page endpoints
  - name: Async tasks
    description: Async task endpoints
  - name: Blocks
    description: Block endpoints
  - name: Comments
    description: Comment endpoints
  - name: File uploads
    description: File upload endpoints
  - name: OAuth
    description: OAuth endpoints (basic authentication)
  - name: Users
    description: User endpoints
  - name: Search
    description: Search endpoints
  - name: Views
    description: View endpoints
  - name: Agents
    description: Agent endpoints
  - name: Sessions
    description: Session endpoints
  - name: Custom emojis
    description: Custom emoji endpoints
  - name: Meeting notes
    description: Meeting notes endpoints
paths:
  /v1/blocks/{block_id}/children:
    patch:
      tags:
        - Blocks
      summary: Append block children
      operationId: patch-block-children
      parameters:
        - name: block_id
          in: path
          required: true
          schema:
            $ref: '#/components/schemas/idRequest'
        - $ref: '#/components/parameters/notionVersion'
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                children:
                  type: array
                  items:
                    $ref: '#/components/schemas/blockObjectRequest'
                  maxItems: 100
                position:
                  $ref: '#/components/schemas/contentPositionSchema'
                notifications:
                  $ref: '#/components/schemas/pageWriteNotificationsSchema'
              additionalProperties: false
              required:
                - children
      responses:
        '200':
          description: ''
          content:
            application/json:
              schema:
                title: Block
                type: object
                properties:
                  type:
                    type: string
                    const: block
                  block:
                    $ref: '#/components/schemas/emptyObject'
                  object:
                    type: string
                    const: list
                  next_cursor:
                    type:
                      - string
                      - 'null'
                  has_more:
                    type: boolean
                  results:
                    type: array
                    items:
                      anyOf:
                        - $ref: '#/components/schemas/partialBlockObjectResponse'
                        - $ref: '#/components/schemas/blockObjectResponse'
                required:
                  - type
                  - block
                  - object
                  - next_cursor
                  - has_more
                  - results
        '400':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/error_api_400'
        '401':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/error_api_401'
        '403':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/error_api_403'
        '404':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/error_api_404'
        '406':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/error_api_406'
        '409':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/error_api_409'
        '429':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/error_api_429'
        '500':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/error_api_500'
        '503':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/error_api_503'
        '504':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/error_api_504'
        '529':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/error_api_529'
      x-codeSamples:
        - lang: javascript
          label: TypeScript SDK
          source: |-
            import { Client } from "@notionhq/client"

            const notion = new Client({ auth: process.env.NOTION_API_KEY })

            const response = await notion.blocks.children.append({
              block_id: "c02fc1d3-db8b-45c5-a222-27595b15aea7",
              children: [
                {
                  type: "paragraph",
                  paragraph: {
                    rich_text: [{ text: { content: "Hello, world!" } }]
                  }
                }
              ]
            })
components:
  schemas:
    idRequest:
      type: string
    blockObjectRequest:
      anyOf:
        - title: Embed
          type: object
          properties:
            embed:
              anyOf:
                - $ref: '#/components/schemas/mediaContentWithUrlAndCaptionRequest'
                - $ref: '#/components/schemas/embedFileUploadRequest'
            type:
              type: string
              const: embed
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - embed
        - title: Bookmark
          type: object
          properties:
            bookmark:
              $ref: '#/components/schemas/mediaContentWithUrlAndCaptionRequest'
            type:
              type: string
              const: bookmark
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - bookmark
        - title: Image
          type: object
          properties:
            image:
              $ref: '#/components/schemas/mediaContentWithFileAndCaptionRequest'
            type:
              type: string
              const: image
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - image
        - title: Video
          type: object
          properties:
            video:
              $ref: '#/components/schemas/mediaContentWithFileAndCaptionRequest'
            type:
              type: string
              const: video
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - video
        - title: Pdf
          type: object
          properties:
            pdf:
              $ref: '#/components/schemas/mediaContentWithFileAndCaptionRequest'
            type:
              type: string
              const: pdf
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - pdf
        - title: File
          type: object
          properties:
            file:
              $ref: '#/components/schemas/mediaContentWithFileNameAndCaptionRequest'
            type:
              type: string
              const: file
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - file
        - title: Audio
          type: object
          properties:
            audio:
              $ref: '#/components/schemas/mediaContentWithFileAndCaptionRequest'
            type:
              type: string
              const: audio
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - audio
        - title: Code
          type: object
          properties:
            code:
              type: object
              properties:
                rich_text:
                  type: array
                  items:
                    $ref: '#/components/schemas/richTextItemRequest'
                  maxItems: 100
                language:
                  $ref: '#/components/schemas/languageRequest'
                caption:
                  type: array
                  items:
                    $ref: '#/components/schemas/richTextItemRequest'
                  maxItems: 100
              additionalProperties: false
              required:
                - rich_text
                - language
            type:
              type: string
              const: code
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - code
        - title: Equation
          type: object
          properties:
            equation:
              $ref: '#/components/schemas/contentWithExpressionRequest'
            type:
              type: string
              const: equation
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - equation
        - title: Divider
          type: object
          properties:
            divider:
              $ref: '#/components/schemas/emptyObject'
            type:
              type: string
              const: divider
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - divider
        - title: Breadcrumb
          type: object
          properties:
            breadcrumb:
              $ref: '#/components/schemas/emptyObject'
            type:
              type: string
              const: breadcrumb
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - breadcrumb
        - title: Tab
          type: object
          properties:
            tab:
              $ref: '#/components/schemas/tabRequestWithNestedTabItemChildren'
            type:
              type: string
              const: tab
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - tab
        - title: Table Of Contents
          type: object
          properties:
            table_of_contents:
              type: object
              properties:
                color:
                  $ref: '#/components/schemas/apiColor'
              additionalProperties: false
            type:
              type: string
              const: table_of_contents
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - table_of_contents
        - title: Link To Page
          type: object
          properties:
            link_to_page:
              anyOf:
                - title: Page Id
                  type: object
                  properties:
                    page_id:
                      $ref: '#/components/schemas/idRequest'
                    type:
                      type: string
                      const: page_id
                  additionalProperties: false
                  required:
                    - page_id
                - title: Database Id
                  type: object
                  properties:
                    database_id:
                      $ref: '#/components/schemas/idRequest'
                    type:
                      type: string
                      const: database_id
                  additionalProperties: false
                  required:
                    - database_id
                - title: Comment Id
                  type: object
                  properties:
                    comment_id:
                      $ref: '#/components/schemas/idRequest'
                    type:
                      type: string
                      const: comment_id
                  additionalProperties: false
                  required:
                    - comment_id
            type:
              type: string
              const: link_to_page
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - link_to_page
        - title: Table Row
          type: object
          properties:
            table_row:
              $ref: '#/components/schemas/contentWithTableRowRequest'
            type:
              type: string
              const: table_row
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - table_row
        - title: Table
          type: object
          properties:
            table:
              $ref: '#/components/schemas/tableRequestWithTableRowChildren'
            type:
              type: string
              const: table
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - table
        - title: Column List
          type: object
          properties:
            column_list:
              $ref: '#/components/schemas/columnListRequest'
            type:
              type: string
              const: column_list
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - column_list
        - title: Column
          type: object
          properties:
            column:
              $ref: '#/components/schemas/columnWithChildrenRequest'
            type:
              type: string
              const: column
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - column
        - title: Heading 1
          type: object
          properties:
            heading_1:
              type: object
              properties:
                rich_text:
                  type: array
                  items:
                    $ref: '#/components/schemas/richTextItemRequest'
                  maxItems: 100
                color:
                  $ref: '#/components/schemas/apiColor'
                is_toggleable:
                  type: boolean
                children:
                  type: array
                  items:
                    $ref: >-
                      #/components/schemas/blockObjectWithSingleLevelOfChildrenRequest
                  maxItems: 100
              additionalProperties: false
              required:
                - rich_text
            type:
              type: string
              const: heading_1
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - heading_1
        - title: Heading 2
          type: object
          properties:
            heading_2:
              type: object
              properties:
                rich_text:
                  type: array
                  items:
                    $ref: '#/components/schemas/richTextItemRequest'
                  maxItems: 100
                color:
                  $ref: '#/components/schemas/apiColor'
                is_toggleable:
                  type: boolean
                children:
                  type: array
                  items:
                    $ref: >-
                      #/components/schemas/blockObjectWithSingleLevelOfChildrenRequest
                  maxItems: 100
              additionalProperties: false
              required:
                - rich_text
            type:
              type: string
              const: heading_2
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - heading_2
        - title: Heading 3
          type: object
          properties:
            heading_3:
              type: object
              properties:
                rich_text:
                  type: array
                  items:
                    $ref: '#/components/schemas/richTextItemRequest'
                  maxItems: 100
                color:
                  $ref: '#/components/schemas/apiColor'
                is_toggleable:
                  type: boolean
                children:
                  type: array
                  items:
                    $ref: >-
                      #/components/schemas/blockObjectWithSingleLevelOfChildrenRequest
                  maxItems: 100
              additionalProperties: false
              required:
                - rich_text
            type:
              type: string
              const: heading_3
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - heading_3
        - title: Heading 4
          type: object
          properties:
            heading_4:
              type: object
              properties:
                rich_text:
                  type: array
                  items:
                    $ref: '#/components/schemas/richTextItemRequest'
                  maxItems: 100
                color:
                  $ref: '#/components/schemas/apiColor'
                is_toggleable:
                  type: boolean
                children:
                  type: array
                  items:
                    $ref: >-
                      #/components/schemas/blockObjectWithSingleLevelOfChildrenRequest
                  maxItems: 100
              additionalProperties: false
              required:
                - rich_text
            type:
              type: string
              const: heading_4
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - heading_4
        - title: Paragraph
          type: object
          properties:
            paragraph:
              type: object
              properties:
                rich_text:
                  type: array
                  items:
                    $ref: '#/components/schemas/richTextItemRequest'
                  maxItems: 100
                color:
                  $ref: '#/components/schemas/apiColor'
                icon:
                  $ref: '#/components/schemas/pageIconRequest'
                children:
                  type: array
                  items:
                    $ref: >-
                      #/components/schemas/blockObjectWithSingleLevelOfChildrenRequest
                  maxItems: 100
              additionalProperties: false
              required:
                - rich_text
            type:
              type: string
              const: paragraph
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - paragraph
        - title: Bulleted List Item
          type: object
          properties:
            bulleted_list_item:
              type: object
              properties:
                rich_text:
                  type: array
                  items:
                    $ref: '#/components/schemas/richTextItemRequest'
                  maxItems: 100
                color:
                  $ref: '#/components/schemas/apiColor'
                children:
                  type: array
                  items:
                    $ref: >-
                      #/components/schemas/blockObjectWithSingleLevelOfChildrenRequest
                  maxItems: 100
              additionalProperties: false
              required:
                - rich_text
            type:
              type: string
              const: bulleted_list_item
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - bulleted_list_item
        - title: Numbered List Item
          type: object
          properties:
            numbered_list_item:
              type: object
              properties:
                rich_text:
                  type: array
                  items:
                    $ref: '#/components/schemas/richTextItemRequest'
                  maxItems: 100
                color:
                  $ref: '#/components/schemas/apiColor'
                children:
                  type: array
                  items:
                    $ref: >-
                      #/components/schemas/blockObjectWithSingleLevelOfChildrenRequest
                  maxItems: 100
              additionalProperties: false
              required:
                - rich_text
            type:
              type: string
              const: numbered_list_item
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - numbered_list_item
        - title: Quote
          type: object
          properties:
            quote:
              type: object
              properties:
                rich_text:
                  type: array
                  items:
                    $ref: '#/components/schemas/richTextItemRequest'
                  maxItems: 100
                color:
                  $ref: '#/components/schemas/apiColor'
                children:
                  type: array
                  items:
                    $ref: >-
                      #/components/schemas/blockObjectWithSingleLevelOfChildrenRequest
                  maxItems: 100
              additionalProperties: false
              required:
                - rich_text
            type:
              type: string
              const: quote
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - quote
        - title: To Do
          type: object
          properties:
            to_do:
              type: object
              properties:
                rich_text:
                  type: array
                  items:
                    $ref: '#/components/schemas/richTextItemRequest'
                  maxItems: 100
                color:
                  $ref: '#/components/schemas/apiColor'
                children:
                  type: array
                  items:
                    $ref: >-
                      #/components/schemas/blockObjectWithSingleLevelOfChildrenRequest
                  maxItems: 100
                checked:
                  type: boolean
              additionalProperties: false
              required:
                - rich_text
            type:
              type: string
              const: to_do
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - to_do
        - title: Toggle
          type: object
          properties:
            toggle:
              type: object
              properties:
                rich_text:
                  type: array
                  items:
                    $ref: '#/components/schemas/richTextItemRequest'
                  maxItems: 100
                color:
                  $ref: '#/components/schemas/apiColor'
                children:
                  type: array
                  items:
                    $ref: >-
                      #/components/schemas/blockObjectWithSingleLevelOfChildrenRequest
                  maxItems: 100
              additionalProperties: false
              required:
                - rich_text
            type:
              type: string
              const: toggle
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - toggle
        - title: Template
          type: object
          properties:
            template:
              type: object
              properties:
                rich_text:
                  type: array
                  items:
                    $ref: '#/components/schemas/richTextItemRequest'
                  maxItems: 100
                children:
                  type: array
                  items:
                    $ref: >-
                      #/components/schemas/blockObjectWithSingleLevelOfChildrenRequest
                  maxItems: 100
              additionalProperties: false
              required:
                - rich_text
            type:
              type: string
              const: template
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - template
        - title: Callout
          type: object
          properties:
            callout:
              type: object
              properties:
                rich_text:
                  type: array
                  items:
                    $ref: '#/components/schemas/richTextItemRequest'
                  maxItems: 100
                color:
                  $ref: '#/components/schemas/apiColor'
                icon:
                  $ref: '#/components/schemas/pageIconRequest'
                children:
                  type: array
                  items:
                    $ref: >-
                      #/components/schemas/blockObjectWithSingleLevelOfChildrenRequest
                  maxItems: 100
              additionalProperties: false
              required:
                - rich_text
            type:
              type: string
              const: callout
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - callout
        - title: Synced Block
          type: object
          properties:
            synced_block:
              type: object
              properties:
                synced_from:
                  title: Block Id
                  type:
                    - object
                    - 'null'
                  properties:
                    block_id:
                      $ref: '#/components/schemas/idRequest'
                    type:
                      type: string
                      const: block_id
                  additionalProperties: false
                  required:
                    - block_id
                children:
                  type: array
                  items:
                    $ref: >-
                      #/components/schemas/blockObjectWithSingleLevelOfChildrenRequest
                  maxItems: 100
              additionalProperties: false
              required:
                - synced_from
            type:
              type: string
              const: synced_block
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - synced_block
    contentPositionSchema:
      anyOf:
        - type: object
          properties:
            type:
              type: string
              const: after_block
            after_block:
              type: object
              properties:
                id:
                  $ref: '#/components/schemas/idRequest'
              required:
                - id
          required:
            - type
            - after_block
        - type: object
          properties:
            type:
              type: string
              const: start
          required:
            - type
        - type: object
          properties:
            type:
              type: string
              const: end
          required:
            - type
    pageWriteNotificationsSchema:
      description: >-
        Controls the notifications Notion sends people about this change. Set
        mode to "silent" to skip page update notifications, @mention
        notifications, and notifications to people added to a Person property,
        or "default" to use the standard behavior. Database automations,
        reminders, and connection webhooks still work as usual. Page history,
        page activity, and workspace audit logs still record the change.
      type: object
      properties:
        mode:
          type: string
          enum:
            - default
            - silent
      required:
        - mode
    emptyObject:
      type: object
      properties: {}
      additionalProperties: false
    partialBlockObjectResponse:
      type: object
      properties:
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
      required:
        - object
        - id
    blockObjectResponse:
      anyOf:
        - $ref: '#/components/schemas/paragraphBlockObjectResponse'
        - $ref: '#/components/schemas/heading1BlockObjectResponse'
        - $ref: '#/components/schemas/heading2BlockObjectResponse'
        - $ref: '#/components/schemas/heading3BlockObjectResponse'
        - $ref: '#/components/schemas/heading4BlockObjectResponse'
        - $ref: '#/components/schemas/bulletedListItemBlockObjectResponse'
        - $ref: '#/components/schemas/numberedListItemBlockObjectResponse'
        - $ref: '#/components/schemas/quoteBlockObjectResponse'
        - $ref: '#/components/schemas/toDoBlockObjectResponse'
        - $ref: '#/components/schemas/toggleBlockObjectResponse'
        - $ref: '#/components/schemas/templateBlockObjectResponse'
        - $ref: '#/components/schemas/syncedBlockBlockObjectResponse'
        - $ref: '#/components/schemas/childPageBlockObjectResponse'
        - $ref: '#/components/schemas/childDatabaseBlockObjectResponse'
        - $ref: '#/components/schemas/equationBlockObjectResponse'
        - $ref: '#/components/schemas/codeBlockObjectResponse'
        - $ref: '#/components/schemas/calloutBlockObjectResponse'
        - $ref: '#/components/schemas/dividerBlockObjectResponse'
        - $ref: '#/components/schemas/breadcrumbBlockObjectResponse'
        - $ref: '#/components/schemas/tableOfContentsBlockObjectResponse'
        - $ref: '#/components/schemas/tabBlockObjectResponse'
        - $ref: '#/components/schemas/columnListBlockObjectResponse'
        - $ref: '#/components/schemas/columnBlockObjectResponse'
        - $ref: '#/components/schemas/linkToPageBlockObjectResponse'
        - $ref: '#/components/schemas/tableBlockObjectResponse'
        - $ref: '#/components/schemas/tableRowBlockObjectResponse'
        - $ref: '#/components/schemas/meetingNotesBlockObjectResponse'
        - $ref: '#/components/schemas/embedBlockObjectResponse'
        - $ref: '#/components/schemas/bookmarkBlockObjectResponse'
        - $ref: '#/components/schemas/imageBlockObjectResponse'
        - $ref: '#/components/schemas/videoBlockObjectResponse'
        - $ref: '#/components/schemas/pdfBlockObjectResponse'
        - $ref: '#/components/schemas/fileBlockObjectResponse'
        - $ref: '#/components/schemas/audioBlockObjectResponse'
        - $ref: '#/components/schemas/linkPreviewBlockObjectResponse'
        - $ref: '#/components/schemas/unsupportedBlockObjectResponse'
    error_api_400:
      allOf:
        - $ref: '#/components/schemas/publicApiCommonErrorResponse'
        - type: object
          properties:
            code:
              enum:
                - invalid_json
                - invalid_request_url
                - invalid_request
                - missing_version
                - invalid_beta
                - validation_error
                - invalid_credit_limit
            status:
              const: 400
          required:
            - code
            - status
          additionalProperties: false
    error_api_401:
      allOf:
        - $ref: '#/components/schemas/publicApiCommonErrorResponse'
        - type: object
          properties:
            code:
              enum:
                - unauthorized
            status:
              const: 401
          required:
            - code
            - status
          additionalProperties: false
    error_api_403:
      oneOf:
        - allOf:
            - $ref: '#/components/schemas/publicApiCommonErrorResponse'
            - type: object
              properties:
                code:
                  enum:
                    - restricted_resource
                    - status_change_not_allowed
                status:
                  const: 403
              required:
                - code
                - status
              additionalProperties: false
        - allOf:
            - $ref: '#/components/schemas/publicApiCommonErrorResponse'
            - type: object
              properties:
                code:
                  const: workspace_credits_exhausted
                status:
                  const: 403
                additional_data:
                  type: object
                  properties:
                    tool_error_code:
                      const: workspace_credits_exhausted
                    tool_error_class:
                      const: entitlement_required
                    tool_error_retryable:
                      const: 'false'
                    recovery_kind:
                      enum:
                        - contact_workspace_owner
                        - open_workspace_credit_settings
                      description: The recovery action selected by Notion for the caller.
                    recovery_url:
                      type: string
                      format: uri
                      description: >-
                        Present when recovery_kind directs the caller to a
                        settings page.
                  required:
                    - tool_error_code
                    - tool_error_class
                    - tool_error_retryable
                    - recovery_kind
                  additionalProperties:
                    oneOf:
                      - type: string
                      - type: array
                        items:
                          type: string
              required:
                - code
                - status
                - additional_data
        - allOf:
            - $ref: '#/components/schemas/publicApiCommonErrorResponse'
            - type: object
              properties:
                code:
                  const: agent_credit_limit_reached
                status:
                  const: 403
                additional_data:
                  type: object
                  properties:
                    tool_error_code:
                      const: agent_credit_limit_reached
                    tool_error_class:
                      const: entitlement_required
                    tool_error_retryable:
                      const: 'false'
                    recovery_kind:
                      enum:
                        - contact_workspace_owner
                        - none
                        - open_agent_settings
                        - request_agent_limit_increase
                        - request_pending
                      description: The recovery action selected by Notion for the caller.
                    recovery_url:
                      type: string
                      format: uri
                      description: >-
                        Present when recovery_kind directs the caller to a
                        settings page.
                  required:
                    - tool_error_code
                    - tool_error_class
                    - tool_error_retryable
                    - recovery_kind
                  additionalProperties:
                    oneOf:
                      - type: string
                      - type: array
                        items:
                          type: string
              required:
                - code
                - status
                - additional_data
    error_api_404:
      allOf:
        - $ref: '#/components/schemas/publicApiCommonErrorResponse'
        - type: object
          properties:
            code:
              enum:
                - object_not_found
                - directory_not_found
            status:
              const: 404
          required:
            - code
            - status
          additionalProperties: false
    error_api_406:
      allOf:
        - $ref: '#/components/schemas/publicApiCommonErrorResponse'
        - type: object
          properties:
            code:
              enum:
                - row_limit_exceeded
            status:
              const: 406
          required:
            - code
            - status
          additionalProperties: false
    error_api_409:
      allOf:
        - $ref: '#/components/schemas/publicApiCommonErrorResponse'
        - type: object
          properties:
            code:
              enum:
                - conflict_error
                - idempotency_key_reused
                - agent_deleted
            status:
              const: 409
          required:
            - code
            - status
          additionalProperties: false
    error_api_429:
      allOf:
        - $ref: '#/components/schemas/publicApiCommonErrorResponse'
        - type: object
          properties:
            code:
              enum:
                - rate_limited
            status:
              const: 429
          required:
            - code
            - status
          additionalProperties: false
    error_api_500:
      allOf:
        - $ref: '#/components/schemas/publicApiCommonErrorResponse'
        - type: object
          properties:
            code:
              enum:
                - internal_server_error
            status:
              const: 500
          required:
            - code
            - status
          additionalProperties: false
    error_api_503:
      allOf:
        - $ref: '#/components/schemas/publicApiCommonErrorResponse'
        - type: object
          properties:
            code:
              enum:
                - service_unavailable
            status:
              const: 503
          required:
            - code
            - status
          additionalProperties: false
    error_api_504:
      allOf:
        - $ref: '#/components/schemas/publicApiCommonErrorResponse'
        - type: object
          properties:
            code:
              enum:
                - gateway_timeout
            status:
              const: 504
          required:
            - code
            - status
          additionalProperties: false
    error_api_529:
      allOf:
        - $ref: '#/components/schemas/publicApiCommonErrorResponse'
        - type: object
          properties:
            code:
              enum:
                - service_overload
            status:
              const: 529
          required:
            - code
            - status
          additionalProperties: false
    mediaContentWithUrlAndCaptionRequest:
      type: object
      properties:
        url:
          type: string
        caption:
          type: array
          items:
            $ref: '#/components/schemas/richTextItemRequest'
          maxItems: 100
      additionalProperties: false
      required:
        - url
    embedFileUploadRequest:
      type: object
      properties:
        file_upload:
          $ref: '#/components/schemas/fileUploadIdRequest'
        type:
          type: string
          const: file_upload
        caption:
          type: array
          items:
            $ref: '#/components/schemas/richTextItemRequest'
          maxItems: 100
      additionalProperties: false
      required:
        - file_upload
    mediaContentWithFileAndCaptionRequest:
      anyOf:
        - title: External
          type: object
          properties:
            external:
              $ref: '#/components/schemas/externalFileRequest'
            type:
              type: string
              const: external
            caption:
              type: array
              items:
                $ref: '#/components/schemas/richTextItemRequest'
              maxItems: 100
          additionalProperties: false
          required:
            - external
        - title: File Upload
          type: object
          properties:
            file_upload:
              $ref: '#/components/schemas/fileUploadIdRequest'
            type:
              type: string
              const: file_upload
            caption:
              type: array
              items:
                $ref: '#/components/schemas/richTextItemRequest'
              maxItems: 100
          additionalProperties: false
          required:
            - file_upload
    mediaContentWithFileNameAndCaptionRequest:
      anyOf:
        - title: External
          type: object
          properties:
            external:
              $ref: '#/components/schemas/externalFileRequest'
            type:
              type: string
              const: external
            caption:
              type: array
              items:
                $ref: '#/components/schemas/richTextItemRequest'
              maxItems: 100
            name:
              $ref: '#/components/schemas/stringRequest'
          additionalProperties: false
          required:
            - external
        - title: File Upload
          type: object
          properties:
            file_upload:
              $ref: '#/components/schemas/fileUploadIdRequest'
            type:
              type: string
              const: file_upload
            caption:
              type: array
              items:
                $ref: '#/components/schemas/richTextItemRequest'
              maxItems: 100
            name:
              $ref: '#/components/schemas/stringRequest'
          additionalProperties: false
          required:
            - file_upload
    richTextItemRequest:
      allOf:
        - $ref: '#/components/schemas/richTextItemRequestCommon'
        - oneOf:
            - $ref: '#/components/schemas/textRichTextItemRequest'
            - $ref: '#/components/schemas/mentionRichTextItemRequest'
            - $ref: '#/components/schemas/equationRichTextItemRequest'
    languageRequest:
      type: string
      enum:
        - abap
        - abc
        - agda
        - arduino
        - ascii art
        - assembly
        - bash
        - basic
        - bnf
        - c
        - c#
        - c++
        - clojure
        - coffeescript
        - coq
        - css
        - dart
        - dhall
        - diff
        - docker
        - ebnf
        - elixir
        - elm
        - erlang
        - f#
        - flow
        - fortran
        - gherkin
        - glsl
        - go
        - graphql
        - groovy
        - haskell
        - hcl
        - html
        - idris
        - java
        - javascript
        - json
        - julia
        - kotlin
        - latex
        - less
        - lisp
        - livescript
        - llvm ir
        - lua
        - makefile
        - markdown
        - markup
        - matlab
        - mathematica
        - mermaid
        - nix
        - notion formula
        - objective-c
        - ocaml
        - pascal
        - perl
        - php
        - plain text
        - powershell
        - prolog
        - protobuf
        - purescript
        - python
        - r
        - racket
        - reason
        - ruby
        - rust
        - sass
        - scala
        - scheme
        - scss
        - shell
        - smalltalk
        - solidity
        - sql
        - swift
        - toml
        - typescript
        - vb.net
        - verilog
        - vhdl
        - visual basic
        - webassembly
        - xml
        - yaml
        - java/c/c++/c#
    contentWithExpressionRequest:
      type: object
      properties:
        expression:
          type: string
      additionalProperties: false
      required:
        - expression
    tabRequestWithNestedTabItemChildren:
      type: object
      properties:
        children:
          type: array
          items:
            $ref: '#/components/schemas/tabItemRequestWithSingleLevelOfChildren'
          maxItems: 100
          minItems: 1
      additionalProperties: false
      required:
        - children
    apiColor:
      type: string
      enum:
        - default
        - gray
        - brown
        - orange
        - yellow
        - green
        - blue
        - purple
        - pink
        - red
        - default_background
        - gray_background
        - brown_background
        - orange_background
        - yellow_background
        - green_background
        - blue_background
        - purple_background
        - pink_background
        - red_background
      description: >-
        One of: `default`, `gray`, `brown`, `orange`, `yellow`, `green`, `blue`,
        `purple`, `pink`, `red`, `default_background`, `gray_background`,
        `brown_background`, `orange_background`, `yellow_background`,
        `green_background`, `blue_background`, `purple_background`,
        `pink_background`, `red_background`
    contentWithTableRowRequest:
      type: object
      properties:
        cells:
          type: array
          items:
            type: array
            items:
              $ref: '#/components/schemas/richTextItemRequest'
            maxItems: 100
          maxItems: 100
      additionalProperties: false
      required:
        - cells
    tableRequestWithTableRowChildren:
      type: object
      properties:
        table_width:
          type: integer
          minimum: 1
        children:
          type: array
          items:
            $ref: '#/components/schemas/tableRowRequest'
          maxItems: 100
          minItems: 1
        has_column_header:
          type: boolean
        has_row_header:
          type: boolean
      additionalProperties: false
      required:
        - table_width
        - children
    columnListRequest:
      type: object
      properties:
        children:
          type: array
          items:
            $ref: '#/components/schemas/columnBlockWithChildrenRequest'
          maxItems: 100
          minItems: 2
      additionalProperties: false
      required:
        - children
    columnWithChildrenRequest:
      type: object
      properties:
        children:
          type: array
          items:
            $ref: '#/components/schemas/blockObjectWithSingleLevelOfChildrenRequest'
          maxItems: 100
        width_ratio:
          description: >-
            Ratio between 0 and 1 of the width of this column relative to all
            columns in the list. If not provided, uses an equal width.
          examples:
            - 0.5
          type: number
          exclusiveMinimum: 0
          exclusiveMaximum: 1
      additionalProperties: false
      required:
        - children
    blockObjectWithSingleLevelOfChildrenRequest:
      anyOf:
        - title: Embed
          type: object
          properties:
            embed:
              anyOf:
                - $ref: '#/components/schemas/mediaContentWithUrlAndCaptionRequest'
                - $ref: '#/components/schemas/embedFileUploadRequest'
            type:
              type: string
              const: embed
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - embed
        - title: Bookmark
          type: object
          properties:
            bookmark:
              $ref: '#/components/schemas/mediaContentWithUrlAndCaptionRequest'
            type:
              type: string
              const: bookmark
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - bookmark
        - title: Image
          type: object
          properties:
            image:
              $ref: '#/components/schemas/mediaContentWithFileAndCaptionRequest'
            type:
              type: string
              const: image
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - image
        - title: Video
          type: object
          properties:
            video:
              $ref: '#/components/schemas/mediaContentWithFileAndCaptionRequest'
            type:
              type: string
              const: video
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - video
        - title: Pdf
          type: object
          properties:
            pdf:
              $ref: '#/components/schemas/mediaContentWithFileAndCaptionRequest'
            type:
              type: string
              const: pdf
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - pdf
        - title: File
          type: object
          properties:
            file:
              $ref: '#/components/schemas/mediaContentWithFileNameAndCaptionRequest'
            type:
              type: string
              const: file
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - file
        - title: Audio
          type: object
          properties:
            audio:
              $ref: '#/components/schemas/mediaContentWithFileAndCaptionRequest'
            type:
              type: string
              const: audio
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - audio
        - title: Code
          type: object
          properties:
            code:
              type: object
              properties:
                rich_text:
                  type: array
                  items:
                    $ref: '#/components/schemas/richTextItemRequest'
                  maxItems: 100
                language:
                  $ref: '#/components/schemas/languageRequest'
                caption:
                  type: array
                  items:
                    $ref: '#/components/schemas/richTextItemRequest'
                  maxItems: 100
              additionalProperties: false
              required:
                - rich_text
                - language
            type:
              type: string
              const: code
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - code
        - title: Equation
          type: object
          properties:
            equation:
              $ref: '#/components/schemas/contentWithExpressionRequest'
            type:
              type: string
              const: equation
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - equation
        - title: Divider
          type: object
          properties:
            divider:
              $ref: '#/components/schemas/emptyObject'
            type:
              type: string
              const: divider
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - divider
        - title: Breadcrumb
          type: object
          properties:
            breadcrumb:
              $ref: '#/components/schemas/emptyObject'
            type:
              type: string
              const: breadcrumb
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - breadcrumb
        - title: Tab
          type: object
          properties:
            tab:
              $ref: '#/components/schemas/tabRequestWithTabItemChildren'
            type:
              type: string
              const: tab
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - tab
        - title: Table Of Contents
          type: object
          properties:
            table_of_contents:
              type: object
              properties:
                color:
                  $ref: '#/components/schemas/apiColor'
              additionalProperties: false
            type:
              type: string
              const: table_of_contents
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - table_of_contents
        - title: Link To Page
          type: object
          properties:
            link_to_page:
              anyOf:
                - title: Page Id
                  type: object
                  properties:
                    page_id:
                      $ref: '#/components/schemas/idRequest'
                    type:
                      type: string
                      const: page_id
                  additionalProperties: false
                  required:
                    - page_id
                - title: Database Id
                  type: object
                  properties:
                    database_id:
                      $ref: '#/components/schemas/idRequest'
                    type:
                      type: string
                      const: database_id
                  additionalProperties: false
                  required:
                    - database_id
                - title: Comment Id
                  type: object
                  properties:
                    comment_id:
                      $ref: '#/components/schemas/idRequest'
                    type:
                      type: string
                      const: comment_id
                  additionalProperties: false
                  required:
                    - comment_id
            type:
              type: string
              const: link_to_page
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - link_to_page
        - title: Table Row
          type: object
          properties:
            table_row:
              $ref: '#/components/schemas/contentWithTableRowRequest'
            type:
              type: string
              const: table_row
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - table_row
        - title: Heading 1
          type: object
          properties:
            heading_1:
              $ref: >-
                #/components/schemas/headerContentWithSingleLevelOfChildrenRequest
            type:
              type: string
              const: heading_1
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - heading_1
        - title: Heading 2
          type: object
          properties:
            heading_2:
              $ref: >-
                #/components/schemas/headerContentWithSingleLevelOfChildrenRequest
            type:
              type: string
              const: heading_2
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - heading_2
        - title: Heading 3
          type: object
          properties:
            heading_3:
              $ref: >-
                #/components/schemas/headerContentWithSingleLevelOfChildrenRequest
            type:
              type: string
              const: heading_3
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - heading_3
        - title: Heading 4
          type: object
          properties:
            heading_4:
              $ref: >-
                #/components/schemas/headerContentWithSingleLevelOfChildrenRequest
            type:
              type: string
              const: heading_4
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - heading_4
        - title: Paragraph
          type: object
          properties:
            paragraph:
              $ref: '#/components/schemas/paragraphWithSingleLevelOfChildrenRequest'
            type:
              type: string
              const: paragraph
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - paragraph
        - title: Bulleted List Item
          type: object
          properties:
            bulleted_list_item:
              $ref: '#/components/schemas/contentWithSingleLevelOfChildrenRequest'
            type:
              type: string
              const: bulleted_list_item
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - bulleted_list_item
        - title: Numbered List Item
          type: object
          properties:
            numbered_list_item:
              $ref: '#/components/schemas/contentWithSingleLevelOfChildrenRequest'
            type:
              type: string
              const: numbered_list_item
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - numbered_list_item
        - title: Quote
          type: object
          properties:
            quote:
              $ref: '#/components/schemas/contentWithSingleLevelOfChildrenRequest'
            type:
              type: string
              const: quote
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - quote
        - title: Table
          type: object
          properties:
            table:
              $ref: '#/components/schemas/tableRequestWithTableRowChildren'
            type:
              type: string
              const: table
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - table
        - title: To Do
          type: object
          properties:
            to_do:
              type: object
              properties:
                rich_text:
                  type: array
                  items:
                    $ref: '#/components/schemas/richTextItemRequest'
                  maxItems: 100
                color:
                  $ref: '#/components/schemas/apiColor'
                children:
                  type: array
                  items:
                    $ref: '#/components/schemas/blockObjectRequestWithoutChildren'
                  maxItems: 100
                checked:
                  type: boolean
              additionalProperties: false
              required:
                - rich_text
            type:
              type: string
              const: to_do
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - to_do
        - title: Toggle
          type: object
          properties:
            toggle:
              $ref: '#/components/schemas/contentWithSingleLevelOfChildrenRequest'
            type:
              type: string
              const: toggle
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - toggle
        - title: Template
          type: object
          properties:
            template:
              type: object
              properties:
                rich_text:
                  type: array
                  items:
                    $ref: '#/components/schemas/richTextItemRequest'
                  maxItems: 100
                children:
                  type: array
                  items:
                    $ref: '#/components/schemas/blockObjectRequestWithoutChildren'
                  maxItems: 100
              additionalProperties: false
              required:
                - rich_text
            type:
              type: string
              const: template
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - template
        - title: Callout
          type: object
          properties:
            callout:
              type: object
              properties:
                rich_text:
                  type: array
                  items:
                    $ref: '#/components/schemas/richTextItemRequest'
                  maxItems: 100
                color:
                  $ref: '#/components/schemas/apiColor'
                icon:
                  $ref: '#/components/schemas/pageIconRequest'
                children:
                  type: array
                  items:
                    $ref: '#/components/schemas/blockObjectRequestWithoutChildren'
                  maxItems: 100
              additionalProperties: false
              required:
                - rich_text
            type:
              type: string
              const: callout
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - callout
        - title: Synced Block
          type: object
          properties:
            synced_block:
              type: object
              properties:
                synced_from:
                  title: Block Id
                  type:
                    - object
                    - 'null'
                  properties:
                    block_id:
                      $ref: '#/components/schemas/idRequest'
                    type:
                      type: string
                      const: block_id
                  additionalProperties: false
                  required:
                    - block_id
                children:
                  type: array
                  items:
                    $ref: '#/components/schemas/blockObjectRequestWithoutChildren'
                  maxItems: 100
              additionalProperties: false
              required:
                - synced_from
            type:
              type: string
              const: synced_block
            object:
              type: string
              const: block
          additionalProperties: false
          required:
            - synced_block
    pageIconRequest:
      oneOf:
        - $ref: '#/components/schemas/fileUploadPageIconRequest'
        - $ref: '#/components/schemas/emojiPageIconRequest'
        - $ref: '#/components/schemas/externalPageIconRequest'
        - $ref: '#/components/schemas/customEmojiPageIconRequest'
        - $ref: '#/components/schemas/iconPageIconRequest'
    paragraphBlockObjectResponse:
      title: Paragraph
      type: object
      properties:
        type:
          type: string
          const: paragraph
        paragraph:
          $ref: '#/components/schemas/contentWithRichTextColorAndIconResponse'
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - paragraph
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    heading1BlockObjectResponse:
      title: Heading 1
      type: object
      properties:
        type:
          type: string
          const: heading_1
        heading_1:
          $ref: '#/components/schemas/headerContentWithRichTextAndColorResponse'
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - heading_1
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    heading2BlockObjectResponse:
      title: Heading 2
      type: object
      properties:
        type:
          type: string
          const: heading_2
        heading_2:
          $ref: '#/components/schemas/headerContentWithRichTextAndColorResponse'
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - heading_2
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    heading3BlockObjectResponse:
      title: Heading 3
      type: object
      properties:
        type:
          type: string
          const: heading_3
        heading_3:
          $ref: '#/components/schemas/headerContentWithRichTextAndColorResponse'
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - heading_3
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    heading4BlockObjectResponse:
      title: Heading 4
      type: object
      properties:
        type:
          type: string
          const: heading_4
        heading_4:
          $ref: '#/components/schemas/headerContentWithRichTextAndColorResponse'
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - heading_4
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    bulletedListItemBlockObjectResponse:
      title: Bulleted List Item
      type: object
      properties:
        type:
          type: string
          const: bulleted_list_item
        bulleted_list_item:
          $ref: '#/components/schemas/contentWithRichTextAndColorResponse'
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - bulleted_list_item
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    numberedListItemBlockObjectResponse:
      title: Numbered List Item
      type: object
      properties:
        type:
          type: string
          const: numbered_list_item
        numbered_list_item:
          $ref: '#/components/schemas/contentWithRichTextAndColorAndListResponse'
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - numbered_list_item
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    quoteBlockObjectResponse:
      title: Quote
      type: object
      properties:
        type:
          type: string
          const: quote
        quote:
          $ref: '#/components/schemas/contentWithRichTextAndColorResponse'
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - quote
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    toDoBlockObjectResponse:
      title: To Do
      type: object
      properties:
        type:
          type: string
          const: to_do
        to_do:
          type: object
          properties:
            rich_text:
              type: array
              items:
                $ref: '#/components/schemas/richTextItemResponse'
              maxItems: 100
            color:
              $ref: '#/components/schemas/apiColor'
            checked:
              type: boolean
          required:
            - rich_text
            - color
            - checked
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - to_do
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    toggleBlockObjectResponse:
      title: Toggle
      type: object
      properties:
        type:
          type: string
          const: toggle
        toggle:
          $ref: '#/components/schemas/contentWithRichTextAndColorResponse'
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - toggle
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    templateBlockObjectResponse:
      title: Template
      type: object
      properties:
        type:
          type: string
          const: template
        template:
          type: object
          properties:
            rich_text:
              type: array
              items:
                $ref: '#/components/schemas/richTextItemResponse'
              maxItems: 100
          required:
            - rich_text
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - template
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    syncedBlockBlockObjectResponse:
      title: Synced Block
      type: object
      properties:
        type:
          type: string
          const: synced_block
        synced_block:
          type: object
          properties:
            synced_from:
              title: Block Id
              type:
                - object
                - 'null'
              properties:
                type:
                  type: string
                  const: block_id
                block_id:
                  $ref: '#/components/schemas/idRequest'
              required:
                - type
                - block_id
          required:
            - synced_from
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - synced_block
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    childPageBlockObjectResponse:
      title: Child Page
      type: object
      properties:
        type:
          type: string
          const: child_page
        child_page:
          $ref: '#/components/schemas/titleObjectResponse'
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - child_page
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    childDatabaseBlockObjectResponse:
      title: Child Database
      type: object
      properties:
        type:
          type: string
          const: child_database
        child_database:
          $ref: '#/components/schemas/titleObjectResponse'
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - child_database
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    equationBlockObjectResponse:
      title: Equation
      type: object
      properties:
        type:
          type: string
          const: equation
        equation:
          $ref: '#/components/schemas/expressionObjectResponse'
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - equation
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    codeBlockObjectResponse:
      title: Code
      type: object
      properties:
        type:
          type: string
          const: code
        code:
          type: object
          properties:
            rich_text:
              type: array
              items:
                $ref: '#/components/schemas/richTextItemResponse'
              maxItems: 100
            caption:
              type: array
              items:
                $ref: '#/components/schemas/richTextItemResponse'
              maxItems: 100
            language:
              $ref: '#/components/schemas/languageRequest'
          required:
            - rich_text
            - caption
            - language
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - code
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    calloutBlockObjectResponse:
      title: Callout
      type: object
      properties:
        type:
          type: string
          const: callout
        callout:
          type: object
          properties:
            rich_text:
              type: array
              items:
                $ref: '#/components/schemas/richTextItemResponse'
              maxItems: 100
            color:
              $ref: '#/components/schemas/apiColor'
            icon:
              anyOf:
                - $ref: '#/components/schemas/pageIconResponse'
                - type: 'null'
          required:
            - rich_text
            - color
            - icon
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - callout
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    dividerBlockObjectResponse:
      title: Divider
      type: object
      properties:
        type:
          type: string
          const: divider
        divider:
          $ref: '#/components/schemas/emptyObject'
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - divider
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    breadcrumbBlockObjectResponse:
      title: Breadcrumb
      type: object
      properties:
        type:
          type: string
          const: breadcrumb
        breadcrumb:
          $ref: '#/components/schemas/emptyObject'
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - breadcrumb
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    tableOfContentsBlockObjectResponse:
      title: Table Of Contents
      type: object
      properties:
        type:
          type: string
          const: table_of_contents
        table_of_contents:
          type: object
          properties:
            color:
              $ref: '#/components/schemas/apiColor'
          required:
            - color
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - table_of_contents
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    tabBlockObjectResponse:
      title: Tab
      type: object
      properties:
        type:
          type: string
          const: tab
        tab:
          $ref: '#/components/schemas/emptyObject'
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - tab
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    columnListBlockObjectResponse:
      title: Column List
      type: object
      properties:
        type:
          type: string
          const: column_list
        column_list:
          $ref: '#/components/schemas/emptyObject'
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - column_list
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    columnBlockObjectResponse:
      title: Column
      type: object
      properties:
        type:
          type: string
          const: column
        column:
          $ref: '#/components/schemas/columnResponse'
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - column
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    linkToPageBlockObjectResponse:
      title: Link To Page
      type: object
      properties:
        type:
          type: string
          const: link_to_page
        link_to_page:
          anyOf:
            - title: Page Id
              type: object
              properties:
                type:
                  type: string
                  const: page_id
                page_id:
                  $ref: '#/components/schemas/idRequest'
              required:
                - type
                - page_id
            - title: Database Id
              type: object
              properties:
                type:
                  type: string
                  const: database_id
                database_id:
                  $ref: '#/components/schemas/idRequest'
              required:
                - type
                - database_id
            - title: Comment Id
              type: object
              properties:
                type:
                  type: string
                  const: comment_id
                comment_id:
                  $ref: '#/components/schemas/idRequest'
              required:
                - type
                - comment_id
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - link_to_page
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    tableBlockObjectResponse:
      title: Table
      type: object
      properties:
        type:
          type: string
          const: table
        table:
          $ref: '#/components/schemas/contentWithTableResponse'
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - table
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    tableRowBlockObjectResponse:
      title: Table Row
      type: object
      properties:
        type:
          type: string
          const: table_row
        table_row:
          $ref: '#/components/schemas/contentWithTableRowResponse'
        parent:
          $ref: '#/components/schemas/parentForBlockBasedObjectResponse'
        object:
          type: string
          const: block
        id:
          type: string
          format: uuid
        created_time:
          type: string
          format: date-time
        created_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        last_edited_time:
          type: string
          format: date-time
        last_edited_by:
          $ref: '#/components/schemas/partialUserObjectResponse'
        has_children:
          type: boolean
        in_trash:
          type: boolean
      required:
        - type
        - table_row
        - parent
        - object
        - id
        - created_time
        - created_by
        - last_edited_time
        - last_edited_by
        - has_children
        - in_trash
    meetingNotesBlockObjectResponse:
      title: Meeting Notes
      type: object
      properties:
        type:
          type: string
[...]
